import "package:renderable/renderable.dart";

abstract class TemplateUtils {
  static String stringFromMethod(String className, MethodElement element) {
    String superValue = element.isAbstract ? null : "super.${element.name}";
    if (element.returnType.name == "void") {
      return "Interceptable.applyMethodInterceptor(this, $className, \"${element.name}\", $superValue);";
    }
    return "return Interceptable.applyMethodInterceptor(this, $className, \"${element.name}\", $superValue);";
  }

  static String stringFromAccessor(String className, PropertyAccessorElement element) {
    if (element.isGetter) {
      return stringFromGetter(className, element);
    }

    return stringFromSetter(className, element);
  }

  static String stringFromGetter(String className, PropertyAccessorElement element) {
    assert(element.isGetter == true);
    String superValue = element.isAbstract ? null : "super.${element.name}";
    return "return Interceptable.applyGetterInterceptor(this, $className, \"${element.name}\", $superValue);";
  }

  static String stringFromSetter(String className, PropertyAccessorElement element) {
    assert(element.isSetter == true);
    String superValue = element.isAbstract ? null : "super.${element.name}";
    return "Interceptable.applySetterInterceptor(this, $className, \"${element.name}\", $superValue);";
  }
}
